import type { BaseContract, BigNumber, BytesLike, CallOverrides, PopulatedTransaction, Signer, utils } from "ethers";
import type { FunctionFragment, Result } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type { TypedEventFilter, TypedEvent, TypedListener, OnEvent } from "../../../common";
export interface HyperCoreLibInterface extends utils.Interface {
    functions: {
        "BASE_ASSET_BRIDGE_ADDRESS()": FunctionFragment;
        "BASE_ASSET_BRIDGE_ADDRESS_UINT256()": FunctionFragment;
        "CANCEL_BY_CLOID_HEADER()": FunctionFragment;
        "CORE_USER_EXISTS_PRECOMPILE_ADDRESS()": FunctionFragment;
        "CORE_WRITER_PRECOMPILE_ADDRESS()": FunctionFragment;
        "LIMIT_ORDER_HEADER()": FunctionFragment;
        "SPOT_BALANCE_PRECOMPILE_ADDRESS()": FunctionFragment;
        "SPOT_PX_PRECOMPILE_ADDRESS()": FunctionFragment;
        "SPOT_SEND_HEADER()": FunctionFragment;
        "TOKEN_INFO_PRECOMPILE_ADDRESS()": FunctionFragment;
        "USDC_CORE_DEPOSIT_WALLET_ADDRESS()": FunctionFragment;
        "USDC_CORE_INDEX()": FunctionFragment;
    };
    getFunction(nameOrSignatureOrTopic: "BASE_ASSET_BRIDGE_ADDRESS" | "BASE_ASSET_BRIDGE_ADDRESS_UINT256" | "CANCEL_BY_CLOID_HEADER" | "CORE_USER_EXISTS_PRECOMPILE_ADDRESS" | "CORE_WRITER_PRECOMPILE_ADDRESS" | "LIMIT_ORDER_HEADER" | "SPOT_BALANCE_PRECOMPILE_ADDRESS" | "SPOT_PX_PRECOMPILE_ADDRESS" | "SPOT_SEND_HEADER" | "TOKEN_INFO_PRECOMPILE_ADDRESS" | "USDC_CORE_DEPOSIT_WALLET_ADDRESS" | "USDC_CORE_INDEX"): FunctionFragment;
    encodeFunctionData(functionFragment: "BASE_ASSET_BRIDGE_ADDRESS", values?: undefined): string;
    encodeFunctionData(functionFragment: "BASE_ASSET_BRIDGE_ADDRESS_UINT256", values?: undefined): string;
    encodeFunctionData(functionFragment: "CANCEL_BY_CLOID_HEADER", values?: undefined): string;
    encodeFunctionData(functionFragment: "CORE_USER_EXISTS_PRECOMPILE_ADDRESS", values?: undefined): string;
    encodeFunctionData(functionFragment: "CORE_WRITER_PRECOMPILE_ADDRESS", values?: undefined): string;
    encodeFunctionData(functionFragment: "LIMIT_ORDER_HEADER", values?: undefined): string;
    encodeFunctionData(functionFragment: "SPOT_BALANCE_PRECOMPILE_ADDRESS", values?: undefined): string;
    encodeFunctionData(functionFragment: "SPOT_PX_PRECOMPILE_ADDRESS", values?: undefined): string;
    encodeFunctionData(functionFragment: "SPOT_SEND_HEADER", values?: undefined): string;
    encodeFunctionData(functionFragment: "TOKEN_INFO_PRECOMPILE_ADDRESS", values?: undefined): string;
    encodeFunctionData(functionFragment: "USDC_CORE_DEPOSIT_WALLET_ADDRESS", values?: undefined): string;
    encodeFunctionData(functionFragment: "USDC_CORE_INDEX", values?: undefined): string;
    decodeFunctionResult(functionFragment: "BASE_ASSET_BRIDGE_ADDRESS", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "BASE_ASSET_BRIDGE_ADDRESS_UINT256", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "CANCEL_BY_CLOID_HEADER", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "CORE_USER_EXISTS_PRECOMPILE_ADDRESS", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "CORE_WRITER_PRECOMPILE_ADDRESS", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "LIMIT_ORDER_HEADER", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "SPOT_BALANCE_PRECOMPILE_ADDRESS", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "SPOT_PX_PRECOMPILE_ADDRESS", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "SPOT_SEND_HEADER", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "TOKEN_INFO_PRECOMPILE_ADDRESS", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "USDC_CORE_DEPOSIT_WALLET_ADDRESS", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "USDC_CORE_INDEX", data: BytesLike): Result;
    events: {};
}
export interface HyperCoreLib extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: HyperCoreLibInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        BASE_ASSET_BRIDGE_ADDRESS(overrides?: CallOverrides): Promise<[string]>;
        BASE_ASSET_BRIDGE_ADDRESS_UINT256(overrides?: CallOverrides): Promise<[BigNumber]>;
        CANCEL_BY_CLOID_HEADER(overrides?: CallOverrides): Promise<[string]>;
        CORE_USER_EXISTS_PRECOMPILE_ADDRESS(overrides?: CallOverrides): Promise<[string]>;
        CORE_WRITER_PRECOMPILE_ADDRESS(overrides?: CallOverrides): Promise<[string]>;
        LIMIT_ORDER_HEADER(overrides?: CallOverrides): Promise<[string]>;
        SPOT_BALANCE_PRECOMPILE_ADDRESS(overrides?: CallOverrides): Promise<[string]>;
        SPOT_PX_PRECOMPILE_ADDRESS(overrides?: CallOverrides): Promise<[string]>;
        SPOT_SEND_HEADER(overrides?: CallOverrides): Promise<[string]>;
        TOKEN_INFO_PRECOMPILE_ADDRESS(overrides?: CallOverrides): Promise<[string]>;
        USDC_CORE_DEPOSIT_WALLET_ADDRESS(overrides?: CallOverrides): Promise<[string]>;
        USDC_CORE_INDEX(overrides?: CallOverrides): Promise<[BigNumber]>;
    };
    BASE_ASSET_BRIDGE_ADDRESS(overrides?: CallOverrides): Promise<string>;
    BASE_ASSET_BRIDGE_ADDRESS_UINT256(overrides?: CallOverrides): Promise<BigNumber>;
    CANCEL_BY_CLOID_HEADER(overrides?: CallOverrides): Promise<string>;
    CORE_USER_EXISTS_PRECOMPILE_ADDRESS(overrides?: CallOverrides): Promise<string>;
    CORE_WRITER_PRECOMPILE_ADDRESS(overrides?: CallOverrides): Promise<string>;
    LIMIT_ORDER_HEADER(overrides?: CallOverrides): Promise<string>;
    SPOT_BALANCE_PRECOMPILE_ADDRESS(overrides?: CallOverrides): Promise<string>;
    SPOT_PX_PRECOMPILE_ADDRESS(overrides?: CallOverrides): Promise<string>;
    SPOT_SEND_HEADER(overrides?: CallOverrides): Promise<string>;
    TOKEN_INFO_PRECOMPILE_ADDRESS(overrides?: CallOverrides): Promise<string>;
    USDC_CORE_DEPOSIT_WALLET_ADDRESS(overrides?: CallOverrides): Promise<string>;
    USDC_CORE_INDEX(overrides?: CallOverrides): Promise<BigNumber>;
    callStatic: {
        BASE_ASSET_BRIDGE_ADDRESS(overrides?: CallOverrides): Promise<string>;
        BASE_ASSET_BRIDGE_ADDRESS_UINT256(overrides?: CallOverrides): Promise<BigNumber>;
        CANCEL_BY_CLOID_HEADER(overrides?: CallOverrides): Promise<string>;
        CORE_USER_EXISTS_PRECOMPILE_ADDRESS(overrides?: CallOverrides): Promise<string>;
        CORE_WRITER_PRECOMPILE_ADDRESS(overrides?: CallOverrides): Promise<string>;
        LIMIT_ORDER_HEADER(overrides?: CallOverrides): Promise<string>;
        SPOT_BALANCE_PRECOMPILE_ADDRESS(overrides?: CallOverrides): Promise<string>;
        SPOT_PX_PRECOMPILE_ADDRESS(overrides?: CallOverrides): Promise<string>;
        SPOT_SEND_HEADER(overrides?: CallOverrides): Promise<string>;
        TOKEN_INFO_PRECOMPILE_ADDRESS(overrides?: CallOverrides): Promise<string>;
        USDC_CORE_DEPOSIT_WALLET_ADDRESS(overrides?: CallOverrides): Promise<string>;
        USDC_CORE_INDEX(overrides?: CallOverrides): Promise<BigNumber>;
    };
    filters: {};
    estimateGas: {
        BASE_ASSET_BRIDGE_ADDRESS(overrides?: CallOverrides): Promise<BigNumber>;
        BASE_ASSET_BRIDGE_ADDRESS_UINT256(overrides?: CallOverrides): Promise<BigNumber>;
        CANCEL_BY_CLOID_HEADER(overrides?: CallOverrides): Promise<BigNumber>;
        CORE_USER_EXISTS_PRECOMPILE_ADDRESS(overrides?: CallOverrides): Promise<BigNumber>;
        CORE_WRITER_PRECOMPILE_ADDRESS(overrides?: CallOverrides): Promise<BigNumber>;
        LIMIT_ORDER_HEADER(overrides?: CallOverrides): Promise<BigNumber>;
        SPOT_BALANCE_PRECOMPILE_ADDRESS(overrides?: CallOverrides): Promise<BigNumber>;
        SPOT_PX_PRECOMPILE_ADDRESS(overrides?: CallOverrides): Promise<BigNumber>;
        SPOT_SEND_HEADER(overrides?: CallOverrides): Promise<BigNumber>;
        TOKEN_INFO_PRECOMPILE_ADDRESS(overrides?: CallOverrides): Promise<BigNumber>;
        USDC_CORE_DEPOSIT_WALLET_ADDRESS(overrides?: CallOverrides): Promise<BigNumber>;
        USDC_CORE_INDEX(overrides?: CallOverrides): Promise<BigNumber>;
    };
    populateTransaction: {
        BASE_ASSET_BRIDGE_ADDRESS(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        BASE_ASSET_BRIDGE_ADDRESS_UINT256(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        CANCEL_BY_CLOID_HEADER(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        CORE_USER_EXISTS_PRECOMPILE_ADDRESS(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        CORE_WRITER_PRECOMPILE_ADDRESS(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        LIMIT_ORDER_HEADER(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        SPOT_BALANCE_PRECOMPILE_ADDRESS(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        SPOT_PX_PRECOMPILE_ADDRESS(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        SPOT_SEND_HEADER(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        TOKEN_INFO_PRECOMPILE_ADDRESS(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        USDC_CORE_DEPOSIT_WALLET_ADDRESS(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        USDC_CORE_INDEX(overrides?: CallOverrides): Promise<PopulatedTransaction>;
    };
}
